<?php 

class model_component_core_catalog extends model {
	
	public function get_categories($data = array()) {
		$sql = "SELECT c.* ";
		
		if(isset($data['count_products'])) {
			$sql .= ", COUNT(p.id) AS count_products ";
		}
		
		$sql .= "FROM catalog_categories c ";
		
		if(isset($data['count_products'])) {
			$sql .= "LEFT JOIN catalog_products p ON c.id = p.category_id ";
		}
		
		$sql .= "WHERE 1 ";
		
		if(isset($data['category_id'])) {
			$sql .= "AND c.id = '" . (int)$data['category_id'] . "' ";
		}
		
		if(isset($data['parent_id'])) {
			$sql .= "AND c.parent_id = '" . (int)$data['parent_id'] . "' ";
		}
		
		if(isset($data['url'])) {
			$sql .= "AND c.url = '" . $this->dbh->escape($data['url']) . "' ";
		}
		
		$sql .= "GROUP BY c.id ";
		
		if(isset($data['order'])) {
			$sql .= "ORDER BY " . $this->dbh->escape($data['order']) ." "; 
		} else {
			$sql .= "ORDER BY c.id ASC ";
		}	
		
		if(isset($data['limit'])) {
			$sql .= "LIMIT " . $this->dbh->escape($data['order']) ." "; 
		}
		
		return $this->dbh->query($sql);
	}	
	
	public function get_categories_list($category_id = 0, $modify = true, $data = array()) {
		$results = $this->get_categories(array('parent_id' => $category_id));
		
		foreach($results as &$result) {
			if((int)$category_id !== 0) {
				if($modify) {
					$result['name'] = $data[$category_id]['name'] . ' &rsaquo; ' . $result['name'];
				}
				$result['full_url'] = $data[$category_id]['url'] . '/' . $result['url'];
			} else {
				$result['full_url'] = $result['url'];
			}
			$data[$result['id']] = $result;
			$data = $this->get_categories_list($result['id'], $modify, $data);
		}
		
		return $data;
	}
	
	public function get_category($category_id = 0, $params = array()) {
		$sql = "SELECT c.* ";
		
		if(isset($params['count_products'])) {
			$sql .= ", COUNT(p.id) AS count_products ";
		}
		
		$sql .= " FROM catalog_categories c ";
		
		if(isset($params['count_products'])) {
			$sql .= "LEFT JOIN catalog_products p ON c.id = p.category_id ";
		}
		
		$sql .= "WHERE c.id = '" . (int)$category_id . "' ";
		
		if(isset($params['limit'])) {
			$sql .= "LIMIT " . $this->dbh->escape($params['order']) ." "; 
		}
		
		return $this->dbh->row($sql);
	}
	
	public function get_category_url($category_id, $url = '') {
		$sql = "SELECT parent_id, url FROM catalog_categories WHERE id = '" . (int)$category_id . "'";
		$category = $this->dbh->row($sql);
		$url = '/' . $category['url'] . $url;
		if($category['parent_id'] == 0) {
			return $url;
		} else {
			return $this->get_category_url($category['parent_id'], $url);
		}
	}
	
	public function get_total_products($category_id = false) {
		$sql = "SELECT COUNT(*) AS total_products FROM catalog_products ";
		
		if($category_id !== false) {
			$sql .= "WHERE category_id = '" . (int)$category_id . "'";
		}
		
		$result = $this->dbh->row($sql);
		
		return (int)$result['total_products'];
	}
	
	public function get_products($data = array()) {
		$sql = "SELECT * FROM catalog_products WHERE 1 ";
		
		if(isset($data['product_id'])) {
			$sql .= "AND id = '" . (int)$data['product_id'] . "' ";
		}
		
		if(isset($data['url'])) {
			$sql .= "AND url = '" . $this->dbh->escape($data['url']) . "' ";
		}
		
		if(isset($data['category_id'])) {
			$sql .= "AND category_id = '" . (int)$data['category_id'] . "' ";
		}
		
		if(isset($data['order'])) {
			$sql .= "ORDER BY " . $this->dbh->escape($data['order']) ." "; 
		} else {
			$sql .= "ORDER BY id ASC ";
		}
		
		if(isset($data['limit'])) {
			$sql .= "LIMIT " . $this->dbh->escape($data['limit']) ." "; 
		}
		
		return $this->dbh->query($sql);
	}
	
	public function get_product($product_id = 0) {
		$sql = "SELECT * FROM catalog_products WHERE id = '" . (int)$product_id . "'";
		
		return $this->dbh->row($sql);
	}
	public function add_category($data = array()) {
		$sql = "INSERT INTO catalog_categories (parent_id, name, text, image, title, keywords, description, url, date_add, sort) 
					VALUES (
						'" . (int)$data['parent_id'] . "', 
						'" . $this->dbh->escape($data['name']) . "', 
						'" . $this->dbh->escape($data['text']) . "', 
						'" . $this->dbh->escape($data['image']) . "', 
						'" . $this->dbh->escape($data['title']) . "', 
						'" . $this->dbh->escape($data['keywords']) . "', 
						'" . $this->dbh->escape($data['description']) . "', 
						'" . $this->dbh->escape($data['url']) . "', 
						'" . time() . "', 
						'" . (int)$data['sort'] . "'
					) ";
						
		return $this->dbh->exec($sql);
	}
	
	public function edit_category($data = array()) {
		$sql = "UPDATE catalog_categories SET 
					parent_id = '" . (int)$data['parent_id'] . "',
					name = '" . $this->dbh->escape($data['name']) . "',
					text = '" . $this->dbh->escape($data['text']) . "',
					image = '" . $this->dbh->escape($data['image']) . "',
					title = '" . $this->dbh->escape($data['title']) . "',
					keywords = '" . $this->dbh->escape($data['keywords']) . "',
					description = '" . $this->dbh->escape($data['description']) . "',
					url = '" . $this->dbh->escape($data['url']) . "',
					sort = '" . (int)$data['sort'] . "'
				WHERE id = '" . (int)$data['id'] . "'
					";
		return $this->dbh->exec($sql);
	}
	
	public function delete_category($category_id = 0, $delete_products = false) {
		$sql = "DELETE FROM catalog_categories WHERE id = '" . (int)$category_id . "'";
		
		if($delete_products) {
			$products = $this->get_products($category_id);
			foreach($products as $product) {
				$this->delete_product($product['id']);
			}
		}
		
		return $this->dbh->exec($sql);
	}
	
	public function add_product($data = array()) {
		$sql = "INSERT INTO catalog_products (category_id, name, text, image, title, keywords, description, url, date_add, sort, price, special, quantity) 
					VALUES (
						'" . (int)$data['category_id'] . "',
						'" . $this->dbh->escape($data['name']) . "',
						'" . $this->dbh->escape($data['text']) . "',
						'" . $this->dbh->escape($data['image']) . "',
						'" . $this->dbh->escape($data['title']) . "',
						'" . $this->dbh->escape($data['keywords']) . "',
						'" . $this->dbh->escape($data['description']) . "',
						'" . $this->dbh->escape($data['url']) . "',
						'" . time() . "',
						'" . (int)$data['sort'] . "',
						'" . (float)$data['price'] . "',
						'" . (float)$data['special'] . "',
						'" . (float)$data['quantity'] . "'
					) ";
					
		return $this->dbh->exec($sql);
	}
	
	public function edit_product($data = array()) {
		$sql = "UPDATE catalog_products SET 
					category_id = '" . (int)$data['category_id'] . "',
					name = '" . $this->dbh->escape($data['name']) . "',
					text = '" . $this->dbh->escape($data['text']) . "',
					image = '" . $this->dbh->escape($data['image']) . "',
					title = '" . $this->dbh->escape($data['title']) . "',
					keywords = '" . $this->dbh->escape($data['keywords']) . "',
					description = '" . $this->dbh->escape($data['description']) . "',
					url = '" . $this->dbh->escape($data['url']) . "',
					sort = '" . (int)$data['sort'] . "',
					price = '" . (float)$data['price'] . "',
					special = '" . (float)$data['special'] . "',
					quantity = '" . (float)$data['quantity'] . "'
				WHERE id = '" . (int)$data['id'] . "'
					";
		return $this->dbh->exec($sql);
	}
	
	public function delete_product($product_id = 0) {
		$sql = "DELETE FROM catalog_products WHERE id = '" . (int)$product_id . "'";
		
		return $this->dbh->exec($sql);
	}
	
	public function get_config() {
		// todo: добавить config.ini
		return array(
			'products_per_page' => 16,
			'decimals' => 2,
			'decimal_point' => '.',
			'thousand_point' => ' ',
			'price_suffix' => ' руб.',
		);
	}
	
	public function format_price($price = 0) {
		$config = $this->get_config();
		
		return number_format((float)$price, (int)$config['decimals'], $config['decimal_point'], $config['thousand_point']) . $config['price_suffix'];
	}
	
}