<?php 

/**
* класс менеджера модулей
*/
class controller_component_core_components extends component {
	
	// вывод  активированных модулей
	public function action_index() {
		$this->data['success'] = '';
		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success'] == 'deact') {
				$this->data['success'] = 'Компонент успешно деактивирован';
			} elseif($this->url['params']['success'] == 'act') {
				$this->data['success'] = 'Компонент успешно активирован';
			}
		}
		
		$this->data['components_list'] = $this->model->get_components();
		
		//core::print_r($this->data['modules_list']);
		//core::print_r($this->url);

		$this->data['page_name'] = 'Менеджер компонентов';
		$this->page['title'] = 'Менеджер компонентов';
		$this->page['html'] = $this->load_view();

		return $this->page;
	}
	
	public function action_activate() {
		$this->data['errors'] = array();
	
		$installed_components = $this->model->get_components();
		
		$activated_components = array();
		
		foreach($this->model->get_activated_components() as $component) {
			$activated_components[] = $component['component'];
		}
		
		$this->data['components'] = array();
		
		foreach($installed_components as $component) { 
			if(!in_array($component['dir'], $activated_components)  // исключаем из списка уже установленные компоненты
			 && file_exists(ROOT_DIR . '/modules/components/' . $component['dir'] . '/front_end/controller_component_' . $component['dir'] . '.php') // исключаем из списка компоненты, используемые только в backend
			 && $component['dir'] != 'pages') {
				
				$this->data['components'][] = $component;
			}
		}
		
		if(isset($_POST['component'])) {
			$this->data['component_dir'] = $_POST['component'];
		} elseif(isset($this->url['actions'][1])) {
			$this->data['component_dir'] = $this->url['actions'][1];
		} else {
			$this->data['component_dir'] = false;
		}
		
		if(isset($_POST['name'])) {
			$this->data['name'] = $_POST['name'];
			
			if(empty($_POST['name'])) {
				$this->data['errors'][] = 'Не заполнено название компонента';
			}
		} else {
			$this->data['name'] = '';
		}

		if(isset($_POST['title'])) {
			$this->data['title'] = $_POST['title'];
		} else {
			$this->data['title'] = '';
		}
				
		if(isset($_POST['keywords'])) {
			$this->data['keywords'] = $_POST['keywords'];
		} else {
			$this->data['keywords'] = '';
		}
		
		if(isset($_POST['description'])) {
			$this->data['description'] = $_POST['description'];
		} else {
			$this->data['description'] = '';
		}		
		
		if(isset($_POST['url'])) {
			if(empty($_POST['url'])) {
				$this->data['url'] = $this->data['component_dir'];
			} else {
				$this->data['url'] = $_POST['url'];
			}
		} else {
			$this->data['url'] = '';
		}
		
		if(isset($_POST['component_info']) && !$this->data['errors']) {
			$component = $this->data['component_dir'];
			
			$this->model->activate($this->data);
			
			if(file_exists(ROOT_DIR . '/modules/components/' . $component . '/back_end/controller_component_' . $component . '.php')) {
				$class_name = 'controller_component_' . $component;
				$obj = new $class_name($this->config, $this->url, array('name' => $component), $this->dbh);
				if(method_exists($obj,'action_activate')) {
					$obj->action_activate();
				}
			}
			
			$this->redirect(SITE_URL . '/admin/components/success=act/active=' . $component);
		}
		
		$this->data['text_submit'] = 'Активировать';
		$this->data['page_name'] = 'Активация компонента';
		$this->page['title'] = 'Активация компонента';
		$this->page['html'] = $this->load_view('form');
		
		return $this->page;
	}
	
	public function action_edit() {
		$this->data['errors'] = array();
		
		$component_info = $this->model->get_component($this->url['actions'][1]);
		
		$this->data['id'] = $this->url['actions'][1];
		
		if(isset($_POST['name'])) {
			$this->data['name'] = $_POST['name'];
			
			if(empty($_POST['name'])) {
				$this->data['errors'][] = 'Не заполнено название компонента';
			}
		} else {
			$this->data['name'] = $component_info['name'];
		}

		if(isset($_POST['title'])) {
			$this->data['title'] = $_POST['title'];
		} else {
			$this->data['title'] = $component_info['title'];
		}
				
		if(isset($_POST['keywords'])) {
			$this->data['keywords'] = $_POST['keywords'];
		} else {
			$this->data['keywords'] = $component_info['keywords'];
		}
		
		if(isset($_POST['description'])) {
			$this->data['description'] = $_POST['description'];
		} else {
			$this->data['description'] = $component_info['description'];
		}		
		
		if(isset($_POST['url'])) {
			if(empty($_POST['url'])) {
				$this->data['url'] = $this->data['component_dir'];
			} else {
				$this->data['url'] = $_POST['url'];
			}
		} else {
			$this->data['url'] = $component_info['url'];
		}
		
		if(isset($_POST['component_info']) && !$this->data['errors']) {
			$this->model->edit($this->data);
			
			$this->redirect(SITE_URL . '/admin/pages/success=c_edit/edited=' . $component_info['id']);
		}
		
		$this->data['text_submit'] = 'Сохранить изменения';
		$this->data['page_name'] = 'Редактирование компонента ' . $component_info['name'];
		$this->page['title'] = 'Редактирование компонента';
		$this->page['html'] = $this->load_view('form');
		
		return $this->page;
	}
	
	public function action_deactivate() {
		if(!isset($this->url['actions'][1])) {
			$this->redirect(SITE_URL . '/admin/pages');
		}
		
		$component_info = $this->model->get_component($this->url['actions'][1]);
		
		if(!$component_info) {
			$this->redirect(SITE_URL . '/admin/pages');
		}
		
		$class_name = 'controller_component_' . $component_info['component'];
		
		$obj = new $class_name($this->config, $this->url, array('name' => $component_info['component']), $this->dbh);
		
		if(method_exists($obj,'action_deactivate')) {
			$obj->action_deactivate();
		}
		
		$this->model->deactivate($this->url['actions'][1]);
		
		$this->redirect(SITE_URL . '/admin/components/success=deact');
		
	}
}